Index: base/common/src/com/netscape/cms/servlet/csadmin/NamePanel.java
===================================================================
--- base/common/src/com/netscape/cms/servlet/csadmin/NamePanel.java	(revision 2521)
+++ base/common/src/com/netscape/cms/servlet/csadmin/NamePanel.java	(working copy)
@@ -435,7 +435,7 @@
          */
 
         // for system certs verification
-	    if (!token.equals("Internal Key Storage Token") && !token.equals("")) {
+	if (!token.equals("Internal Key Storage Token") && !token.equals("")) {
             config.putString(subsystem + ".cert." + certTag + ".nickname",
                 token + ":" +  nickname);
         } else {
@@ -936,14 +936,11 @@
                                                        httpsPortStr,
                                                        "CA" );
 
-        int httpsport = -1;
-
+        int admin_port = -1;
         try {
-             httpsport = Integer.parseInt(httpsPortStr);
+             admin_port = Integer.parseInt(https_admin_port);
         } catch (Exception e) {
-            CMS.debug(
-                    "NamePanel update: Https port is not valid. Exception: "
-                            + e.toString());
+            CMS.debug("NamePanel update: Https port is not valid. Exception: " + e.toString());
             throw new IOException("Https Port is not valid.");
         }
 
@@ -951,9 +948,9 @@
         config.putString("preop.ca.httpsport", httpsPortStr);
         config.putString("preop.ca.httpsadminport", https_admin_port);
         ConfigCertApprovalCallback certApprovalCallback = new ConfigCertApprovalCallback();
-        updateCertChainUsingSecureEEPort( config, "ca", hostname,
-                                          httpsport, true, context,
-                                          certApprovalCallback );
+        updateCertChain(config, "ca", hostname, admin_port,
+                        true, context, certApprovalCallback );
+
         try {
            CMS.debug("Importing CA chain");
            importCertChain("ca");
Index: base/common/src/com/netscape/cms/servlet/csadmin/CreateSubsystemPanel.java
===================================================================
--- base/common/src/com/netscape/cms/servlet/csadmin/CreateSubsystemPanel.java	(revision 2521)
+++ base/common/src/com/netscape/cms/servlet/csadmin/CreateSubsystemPanel.java	(working copy)
@@ -199,43 +199,34 @@
             throw new IOException("choice not found");
         }
 
-        config.putString("preop.subsystem.name", 
-              HttpInput.getName(request, "subsystemName"));
-        if (select.equals("newsubsystem")) {
-            config.putString("preop.subsystem.select", "new");
-            config.putString("subsystem.select", "New");
-        } else if (select.equals("clonesubsystem")) {
-            String cstype = "";
-            try {
-                cstype = config.getString("cs.type", "");
-            } catch (Exception e) {
-            }
-
-            cstype = toLowerCaseSubsystemType(cstype);
+        try {
+            config.putString("preop.subsystem.name", 
+                HttpInput.getName(request, "subsystemName"));
+            if (select.equals("newsubsystem")) {
+                config.putString("preop.subsystem.select", "new");
+                config.putString("subsystem.select", "New");
+            } else if (select.equals("clonesubsystem")) {
+                String cstype = config.getString("cs.type", "");
+                cstype = toLowerCaseSubsystemType(cstype);
       
-            config.putString("preop.subsystem.select", "clone");
-            config.putString("subsystem.select", "Clone");
+                config.putString("preop.subsystem.select", "clone");
+                config.putString("subsystem.select", "Clone");
 
-            String lists = "";
-            try {
-                lists = config.getString("preop.cert.list", "");
-            } catch (Exception ee) {
-            }
+                String lists = config.getString("preop.cert.list", "");
 
-            StringTokenizer t = new StringTokenizer(lists, ",");
-            while (t.hasMoreTokens()) {
-                String tag = t.nextToken();
-                if (tag.equals("sslserver"))
-                    config.putBoolean(PCERT_PREFIX+tag+".enable", true);
-                else 
-                    config.putBoolean(PCERT_PREFIX+tag+".enable", false);
-            }
+                StringTokenizer t = new StringTokenizer(lists, ",");
+                while (t.hasMoreTokens()) {
+                    String tag = t.nextToken();
+                    if (tag.equals("sslserver"))
+                        config.putBoolean(PCERT_PREFIX+tag+".enable", true);
+                    else 
+                        config.putBoolean(PCERT_PREFIX+tag+".enable", false);
+                }
 
-            // get the master CA
-            String index = request.getParameter("urls");
-            String url = "";
+                // get the master CA
+                String index = request.getParameter("urls");
+                String url = "";
 
-            try {
                 int x = Integer.parseInt(index);
                 String list = config.getString("preop.master.list", "");
                 StringTokenizer tokenizer = new StringTokenizer(list, ",");
@@ -248,46 +239,44 @@
                     }
                     counter++;
                 }
-            } catch (Exception e) {
-            }
 
-            url = url.substring(url.indexOf("http"));
+                url = url.substring(url.indexOf("http"));
 
-            URL u = new URL(url);
-            String host = u.getHost();
-            int https_ee_port = u.getPort();
+                URL u = new URL(url);
+                String host = u.getHost();
+                int https_ee_port = u.getPort();
 
-            String https_admin_port = getSecurityDomainAdminPort( config,
-                                                                  host,
-                                                                  String.valueOf(https_ee_port),
-                                                                  cstype );
+                String https_admin_port = getSecurityDomainAdminPort( config,
+                                                                      host,
+                                                                      String.valueOf(https_ee_port),
+                                                                      cstype );
 
-            config.putString("preop.master.hostname", host);
-            config.putInteger("preop.master.httpsport", https_ee_port);
-            config.putString("preop.master.httpsadminport", https_admin_port);
+                config.putString("preop.master.hostname", host);
+                config.putInteger("preop.master.httpsport", https_ee_port);
+                config.putString("preop.master.httpsadminport", https_admin_port);
 
-            ConfigCertApprovalCallback certApprovalCallback = new ConfigCertApprovalCallback();
-            if (cstype.equals("ca")) {
-                updateCertChainUsingSecureEEPort( config, "clone", host, https_ee_port,
+                ConfigCertApprovalCallback certApprovalCallback = new ConfigCertApprovalCallback();
+                if (cstype.equals("ca")) {
+                    updateCertChain( config, "clone", host, Integer.parseInt(https_admin_port),
                                  true, context, certApprovalCallback );
+                }
+            } else {
+                CMS.debug("CreateSubsystemPanel: invalid choice " + select);
+                errorString = "Invalid choice";
+                context.put("updateStatus", "failure");
+                throw new IOException("invalid choice " + select);
             }
 
-            getTokenInfo(config, cstype, host, https_ee_port, true, context, 
-              certApprovalCallback);
-        } else {
-            CMS.debug("CreateSubsystemPanel: invalid choice " + select);
-            errorString = "Invalid choice";
-            context.put("updateStatus", "failure");
-            throw new IOException("invalid choice " + select);
-        }
-
-        try {
             config.commit(false);
-        } catch (EBaseException e) {
-        }
 
-        context.put("errorString", errorString);
-        context.put("updateStatus", "success");
+            context.put("errorString", errorString);
+            context.put("updateStatus", "success");
+        } catch (Exception e) {
+            CMS.debug("CreateSubsystemPanel: Exception thrown : " + e);
+            context.put("errorString", e.toString());
+            context.put("updateStatus", "failure");
+            throw new IOException(e);
+        }
     }
 
     /**
Index: base/common/src/com/netscape/cms/servlet/csadmin/RestoreKeyCertPanel.java
===================================================================
--- base/common/src/com/netscape/cms/servlet/csadmin/RestoreKeyCertPanel.java	(revision 2521)
+++ base/common/src/com/netscape/cms/servlet/csadmin/RestoreKeyCertPanel.java	(working copy)
@@ -17,7 +17,6 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cms.servlet.csadmin;
 
-
 import org.apache.velocity.Template;
 import org.apache.velocity.servlet.VelocityServlet;
 import org.apache.velocity.app.Velocity;
@@ -47,6 +46,10 @@
 import com.netscape.cms.servlet.wizard.*;
 import netscape.ldap.*;
 import java.security.interfaces.*;
+import java.security.cert.CertificateException;
+import org.mozilla.jss.CryptoManager.NicknameConflictException;
+import org.mozilla.jss.CryptoManager.NotInitializedException;
+import org.mozilla.jss.CryptoManager.UserCertConflictException;
 
 public class RestoreKeyCertPanel extends WizardPanelBase {
 
@@ -194,146 +197,134 @@
             Context context) throws IOException 
     {
         IConfigStore config = CMS.getConfigStore();
-        String path = HttpInput.getString(request, "path");
-        if (path == null || path.equals("")) {
-              // skip to next panel
-            config.putBoolean("preop.restorekeycert.done", true);
-            try {
-              config.commit(false);
-            } catch (EBaseException e) {
+        try {
+            getConfigEntriesFromMaster(request, response, context);
+
+            String path = HttpInput.getString(request, "path");
+            if (path == null || path.equals("")) {
+                // skip to next panel
+                config.putBoolean("preop.restorekeycert.done", true);
+                config.commit(false);
+                context.put("updateStatus", "success");
+                return;
             }
-            getConfigEntriesFromMaster(request, response, context);
-            context.put("updateStatus", "success");
-            return;
-        }
-        String pwd = HttpInput.getPassword(request, "__password");
+
+            String pwd = HttpInput.getPassword(request, "__password");
         
-        String tokenn = "";
-        String instanceRoot = "";
+            String tokenn = config.getString("preop.module.token");
+            if (tokenn.equals("Internal Key Storage Token")) {
+                String instanceRoot = config.getString("instanceRoot");
+                String p12File = instanceRoot + File.separator + "alias" +
+                                 File.separator + path;
+                restoreCertsFromP12(p12File, pwd);
+            }
 
-        try {
-            tokenn = config.getString("preop.module.token");
-            instanceRoot = config.getString("instanceRoot");
+            String subsystemtype = config.getString("preop.subsystem.select", "");
+            if (subsystemtype.equals("clone")) {
+                CMS.debug("RestoreKeyCertPanel: this is the clone subsystem"); 
+                boolean cloneReady = isCertdbCloned(request, context);
+                if (!cloneReady) {
+                    CMS.debug("RestoreKeyCertPanel update: clone does not have all the certificates.");
+                    throw new IOException("Clone is not ready");
+                }
+            }
+
+            config.putBoolean("preop.restorekeycert.done", true);
+            config.commit(false);
         } catch (Exception e) {
+            CMS.debug("RestoreKeyCertPanel update: exception thrown:" + e);
+            e.printStackTrace();
+            context.put("errorString", e.toString());
+            context.put("updateStatus", "failure");
+            throw new IOException(e);
+        } 
+        context.put("updateStatus", "success");
+    }
+
+    private void restoreCertsFromP12(String p12File, String p12Pass) throws EPropertyNotFound, EBaseException,
+            InvalidKeyException, CertificateException, NoSuchAlgorithmException, IllegalStateException,
+            InvalidAlgorithmParameterException, TokenException, IllegalBlockSizeException,
+            BadPaddingException, NotInitializedException, NicknameConflictException, UserCertConflictException,
+            NoSuchItemOnTokenException, InvalidBERException, IOException{
+        byte b[] = new byte[1000000];
+        FileInputStream fis = new FileInputStream(p12File);
+        while (fis.available() > 0) {
+            fis.read(b);
         }
+        fis.close();
 
-        if (tokenn.equals("Internal Key Storage Token")) {
-            byte b[] = new byte[1000000];
-            FileInputStream fis = new FileInputStream(instanceRoot + "/alias/" + path);
-            while (fis.available() > 0) 
-                fis.read(b);
-            fis.close();
+        ByteArrayInputStream bis = new ByteArrayInputStream(b);
+        StringBuffer reason = new StringBuffer();
+        Password password = new Password(p12Pass.toCharArray());
+        PFX pfx = null;
+        boolean verifypfx = false;
 
-            ByteArrayInputStream bis = new ByteArrayInputStream(b);
-            StringBuffer reason = new StringBuffer();
-            Password password = new Password(pwd.toCharArray());
-            PFX pfx = null;
-            boolean verifypfx = false;
-            try {
-                pfx = (PFX)(new PFX.Template()).decode(bis);
-                verifypfx = pfx.verifyAuthSafes(password, reason); 
-            } catch (Exception e) {
-                CMS.debug("RestoreKeyCertPanel update: Exception="+e.toString());
-            }
+        pfx = (PFX)(new PFX.Template()).decode(bis);
+        verifypfx = pfx.verifyAuthSafes(password, reason); 
 
-            if (verifypfx) {
-                CMS.debug("RestoreKeyCertPanel verify the PFX.");
-                AuthenticatedSafes safes = pfx.getAuthSafes();
-                Vector pkeyinfo_collection = new Vector();
-                Vector cert_collection = new Vector();
-                for (int i=0; i<safes.getSize(); i++) {
-                    try {
-                        SEQUENCE scontent = safes.getSafeContentsAt(null, i); 
-                        for (int j=0; j<scontent.size(); j++) {
-                            SafeBag bag = (SafeBag)scontent.elementAt(j);
-                            OBJECT_IDENTIFIER oid = bag.getBagType();
-                            if (oid.equals(SafeBag.PKCS8_SHROUDED_KEY_BAG)) {
-                                EncryptedPrivateKeyInfo privkeyinfo = 
-                                  (EncryptedPrivateKeyInfo)bag.getInterpretedBagContent();
-                                PasswordConverter passConverter = new PasswordConverter();
-                                PrivateKeyInfo pkeyinfo = privkeyinfo.decrypt(password, new PasswordConverter());
-                                Vector pkeyinfo_v = new Vector();
-                                pkeyinfo_v.addElement(pkeyinfo);
-                                SET bagAttrs = bag.getBagAttributes();
-                                for (int k=0; k<bagAttrs.size(); k++) {
-                                    Attribute attrs = (Attribute)bagAttrs.elementAt(k);
-                                    OBJECT_IDENTIFIER aoid = attrs.getType();
-                                    if (aoid.equals(SafeBag.FRIENDLY_NAME)) {
-                                        SET val = attrs.getValues();
-                                        ANY ss = (ANY)val.elementAt(0);
-                                        ByteArrayInputStream bbis = new ByteArrayInputStream(ss.getEncoded());
-                                        BMPString sss = (BMPString)(new BMPString.Template()).decode(bbis);
-                                        String s = sss.toString();
-                                        pkeyinfo_v.addElement(s);
-                                    }
-                                }
-                                pkeyinfo_collection.addElement(pkeyinfo_v);
-                            } else if (oid.equals(SafeBag.CERT_BAG)) {
-                                CertBag cbag = (CertBag)bag.getInterpretedBagContent();    
-                                OCTET_STRING str = (OCTET_STRING)cbag.getInterpretedCert();
-                                byte[] x509cert = str.toByteArray();
-                                Vector cert_v = new Vector();
-                                cert_v.addElement(x509cert);
-                                SET bagAttrs = bag.getBagAttributes();
+        if (verifypfx) {
+            CMS.debug("RestoreKeyCertPanel verify the PFX.");
+            AuthenticatedSafes safes = pfx.getAuthSafes();
+            Vector pkeyinfo_collection = new Vector();
+            Vector cert_collection = new Vector();
+            for (int i=0; i<safes.getSize(); i++) {
+                SEQUENCE scontent = safes.getSafeContentsAt(null, i); 
+                for (int j=0; j<scontent.size(); j++) {
+                    SafeBag bag = (SafeBag)scontent.elementAt(j);
+                    OBJECT_IDENTIFIER oid = bag.getBagType();
+                    if (oid.equals(SafeBag.PKCS8_SHROUDED_KEY_BAG)) {
+                        EncryptedPrivateKeyInfo privkeyinfo = 
+                          (EncryptedPrivateKeyInfo)bag.getInterpretedBagContent();
+                        PasswordConverter passConverter = new PasswordConverter();
+                        PrivateKeyInfo pkeyinfo = privkeyinfo.decrypt(password, new PasswordConverter());
+                        Vector pkeyinfo_v = new Vector();
+                        pkeyinfo_v.addElement(pkeyinfo);
+                        SET bagAttrs = bag.getBagAttributes();
+                        for (int k=0; k<bagAttrs.size(); k++) {
+                            Attribute attrs = (Attribute)bagAttrs.elementAt(k);
+                            OBJECT_IDENTIFIER aoid = attrs.getType();
+                            if (aoid.equals(SafeBag.FRIENDLY_NAME)) {
+                                SET val = attrs.getValues();
+                                ANY ss = (ANY)val.elementAt(0);
+                                ByteArrayInputStream bbis = new ByteArrayInputStream(ss.getEncoded());
+                                BMPString sss = (BMPString)(new BMPString.Template()).decode(bbis);
+                                String s = sss.toString();
+                                pkeyinfo_v.addElement(s);
+                            }
+                        }
+                        pkeyinfo_collection.addElement(pkeyinfo_v);
+                    } else if (oid.equals(SafeBag.CERT_BAG)) {
+                        CertBag cbag = (CertBag)bag.getInterpretedBagContent();    
+                        OCTET_STRING str = (OCTET_STRING)cbag.getInterpretedCert();
+                        byte[] x509cert = str.toByteArray();
+                        Vector cert_v = new Vector();
+                        cert_v.addElement(x509cert);
+                        SET bagAttrs = bag.getBagAttributes();
                          
-                                if (bagAttrs != null) {
-                                    for (int k=0; k<bagAttrs.size(); k++) {
-                                        Attribute attrs = (Attribute)bagAttrs.elementAt(k);
-                                        OBJECT_IDENTIFIER aoid = attrs.getType();
-                                        if (aoid.equals(SafeBag.FRIENDLY_NAME)) {
-                                            SET val = attrs.getValues();
-                                            ANY ss = (ANY)val.elementAt(0);
-                                            ByteArrayInputStream bbis = new ByteArrayInputStream(ss.getEncoded());
-                                            BMPString sss = (BMPString)(new BMPString.Template()).decode(bbis);
-                                            String s = sss.toString();
-                                            cert_v.addElement(s);
-                                        }
-                                    }
+                        if (bagAttrs != null) {
+                            for (int k=0; k<bagAttrs.size(); k++) {
+                                Attribute attrs = (Attribute)bagAttrs.elementAt(k);
+                                OBJECT_IDENTIFIER aoid = attrs.getType();
+                                if (aoid.equals(SafeBag.FRIENDLY_NAME)) {
+                                    SET val = attrs.getValues();
+                                    ANY ss = (ANY)val.elementAt(0);
+                                    ByteArrayInputStream bbis = new ByteArrayInputStream(ss.getEncoded());
+                                    BMPString sss = (BMPString)(new BMPString.Template()).decode(bbis);
+                                    String s = sss.toString();
+                                    cert_v.addElement(s);
                                 }
-
-                                cert_collection.addElement(cert_v);
                             }
                         }
-                    } catch (Exception e) {
-                        CMS.debug("RestoreKeyCertPanel update: Exception="+e.toString());
+
+                        cert_collection.addElement(cert_v);
                     }
                 }
-            
-                importkeycert(pkeyinfo_collection, cert_collection);
-            } else {
-                context.put("updateStatus", "failure");
-                throw new IOException("The pkcs12 file is not correct.");
             }
+        
+            importkeycert(pkeyinfo_collection, cert_collection);
+        } else {
+            throw new IOException("The pkcs12 file is not correct.");
         }
-
-        String subsystemtype = "";
-        String cstype = "";
-        try {
-            subsystemtype = config.getString("preop.subsystem.select", "");
-            cstype = config.getString("cs.type", "");
-        } catch (Exception e) {
-        }
-        cstype = toLowerCaseSubsystemType(cstype);
-
-        if (subsystemtype.equals("clone")) {
-            CMS.debug("RestoreKeyCertPanel: this is the clone subsystem"); 
-            boolean cloneReady = isCertdbCloned(request, context);
-            if (!cloneReady) {
-                CMS.debug("RestoreKeyCertPanel update: clone does not have all the certificates.");
-                context.put("errorString", "Make sure you have copied the certificate database over to the clone");
-                context.put("updateStatus", "failure");
-                throw new IOException("Clone is not ready");
-            }
-        }
-
-        config.putBoolean("preop.restorekeycert.done", true);
-        try {
-            config.commit(false);
-        } catch (EBaseException e) {
-        }
-
-        getConfigEntriesFromMaster(request, response, context);
-        context.put("updateStatus", "success");
     }
 
     private void getConfigEntriesFromMaster(HttpServletRequest request,
@@ -364,13 +355,16 @@
                 if (cstype.equals("ca") || cstype.equals("kra")) {
                     content = "type=request&xmlOutput=true&sessionID="+session_id;
                     CMS.debug("http content=" + content);
-                    updateNumberRange(master_hostname, master_ee_port, true, content, "request", response);
+                    updateNumberRange(master_hostname, master_ee_port, master_port, true, content, 
+                        "request", response);
 
                     content = "type=serialNo&xmlOutput=true&sessionID="+session_id;
-                    updateNumberRange(master_hostname, master_ee_port, true, content, "serialNo", response);
+                    updateNumberRange(master_hostname, master_ee_port, master_port, true, content, 
+                        "serialNo", response);
 
                     content = "type=replicaId&xmlOutput=true&sessionID="+session_id;
-                    updateNumberRange(master_hostname, master_ee_port, true, content, "replicaId", response);
+                    updateNumberRange(master_hostname, master_ee_port, master_port, true, content, 
+                        "replicaId", response);
                 }
 
                 String list = "";
@@ -496,7 +490,7 @@
     }
 
     private void importkeycert(Vector pkeyinfo_collection, 
-      Vector cert_collection) throws IOException {
+      Vector cert_collection) throws IOException, EBaseException {
         CryptoManager cm = null;
         try {
             cm = CryptoManager.getInstance();
@@ -505,12 +499,21 @@
 
         // delete all existing certificates first
         deleteExistingCerts();
+        ArrayList<String> masterList = getMasterCertKeyList();
 
         for (int i=0; i<pkeyinfo_collection.size(); i++) {
             try {
                 Vector pkeyinfo_v = (Vector)pkeyinfo_collection.elementAt(i);
                 PrivateKeyInfo pkeyinfo = (PrivateKeyInfo)pkeyinfo_v.elementAt(0);
                 String nickname = (String)pkeyinfo_v.elementAt(1);
+
+                if (! masterList.contains(nickname)) {
+                    // TODO: fix this to only import needed keys
+                    CMS.debug("Ignoring " + nickname);
+                    // only import the master's system keys
+                    // continue;
+                }
+
                 byte[] x509cert = getX509Cert(nickname, cert_collection); 
                 X509Certificate cert = cm.importCACertPackage(x509cert);
                 ByteArrayOutputStream bos = new ByteArrayOutputStream();
@@ -550,6 +553,12 @@
                 byte[] cert = (byte[])cert_v.elementAt(0);
                 if (cert_v.size() > 1) {
                     String name = (String)cert_v.elementAt(1);
+                    if (! masterList.contains(name)) {
+                        CMS.debug("Ignoring " + name);
+                        // only import the master's system certs
+                        continue;
+                    }
+
                     // we need to delete the trusted CA certificate if it is
                     // the same as the ca signing certificate
                     if (isCASigningCert(name)) {
@@ -588,6 +597,26 @@
         }
     }
 
+    private ArrayList<String> getMasterCertKeyList() throws EBaseException {
+        ArrayList<String> list = new ArrayList<String>();
+        IConfigStore cs = CMS.getConfigStore();
+        String certList = cs.getString("preop.cert.list", "");
+        StringTokenizer st = new StringTokenizer(certList, ",");
+        while (st.hasMoreTokens()) {
+            String s = st.nextToken();
+            if (s.equals("sslserver"))
+                    continue;
+            String name = "preop.master." + s + ".nickname";
+            String nickname = cs.getString(name);
+            list.add(nickname);
+
+            name = "preop.cert." + s + ".dn";
+            String dn = cs.getString(name);
+            list.add(dn);
+        }
+        return list;
+    }
+
     private boolean isCASigningCert(String name) {
         String n = "preop.master.signing.nickname";
         IConfigStore cs = CMS.getConfigStore();
@@ -665,6 +694,7 @@
             CryptoManager cm = CryptoManager.getInstance();
             certList = config.getString("preop.cert.list");
             StringTokenizer st = new StringTokenizer(certList, ",");
+            String cstype = config.getString("cs.type").toLowerCase();
             while (st.hasMoreTokens()) {
                 String token = st.nextToken();
                 if (token.equals("sslserver"))
@@ -682,6 +712,11 @@
                 X509Certificate cert = cm.findCertByNickname(nickname);
                 if (cert == null)
                     return false;
+
+                // TODO : remove this when we eliminate the extraneous nicknames
+                // needed for self tests cert verification
+                config.putString(cstype + ".cert." + token + ".nickname", nickname);
+
             }
         } catch (Exception e) {
             context.put("errorString", "Check your CS.cfg for cloning");
